<?php

namespace FiloBlu\CheckoutExtend\Controller\Index;


use FiloBlu\CheckoutExtend\Helper\Data;
use FiloBlu\CheckoutExtend\Model\Vat;
use Magento\Framework\App\Action\Context;
use Magento\Framework\Controller\Result\JsonFactory;

class ValidateVat extends \Magento\Framework\App\Action\Action
{

    /**
     * @var JsonFactory
     */
    protected $_resultJsonFactory;
    protected $helperData;
    /**
     * @var Vat
     */
    private $vat;

    /**
     * ValidateVat constructor.
     * @param Context $context
     * @param JsonFactory $resultJsonFactory
     * @param Data $helperData
     * @param Vat $vat
     */
    public function __construct(
        Context $context,
        JsonFactory $resultJsonFactory,
        Data $helperData,
        Vat $vat
    )
    {
        $this->helperData = $helperData;
        $this->_resultJsonFactory = $resultJsonFactory;
        parent::__construct($context);
        $this->vat = $vat;
    }

    public function execute()
    {

        $vatConfig = $this->helperData->getCustomerGroupVatSeparation();
        if ($this->getRequest()->isXmlHttpRequest() || $this->getRequest()->getParam('ajax') || $this->getRequest()->getParam('isAjax')) {
            $resultValue = $this->getResultIsValid();
            $resultJson = $this->_resultJsonFactory->create();
            return $resultJson->setData([
                'success' => $resultValue
            ]);
        }
        return false;

    }
    public function getResultIsValid(){
        $data = $this->getRequest()->getParam('vat-number');
        $result = $this->vat->checkVatNumber($this->getRequest()->getCookie('filoblu_geoip_country'), $data, $this->vat->getMerchantCountryCode(), $this->vat->getMerchantVatNumber());
        $resultValue = $result->getIsValid();
        return $resultValue;
    }
}
